diff --git a/src/backend/utils/cache/shared_cache.c b/src/backend/utils/cache/shared_cache.c
new file mode 100644
index 0000000..a18add1
--- /dev/null
+++ b/src/backend/utils/cache/shared_cache.c
@@ -0,0 +1,523 @@
+/*-------------------------------------------------------------------------
+ *
+ * shared_cache.c
+ *	  Utilities for global system catalog cache and global relation cache
+ *
+ * Portions Copyright (c) 1996-2019, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ *
+ * IDENTIFICATION
+ *	  src/backend/utils/cache/globalcache.c
+ *
+ *-------------------------------------------------------------------------
+ */
+#include "postgres.h"
+
+#include "storage/shmem.h"
+#include "storage/spin.h"
+#include "utils/hsearch.h"
+#include "utils/memutils.h"
+#include "utils/shared_meta_cache.h"
+#include "utils/syscache.h"
+
+#include "miscadmin.h"
+
+
+#define NUM_DB 16 /* arbiary number */
+
+/* shared cache map to find the global catalog or relation hash table */
+static HTAB *GlobalCatCacheMap;
+static HTAB *GlobalRelCacheMap;
+
+//static MemoryContext TempGlobalCacheContext = NULL;
+
+static HandleBlock *InitHandleBlock(void);
+
+static void InitGlobalCatCacheMap(void);
+static void InitGlobalRelCacheMap(void);
+static Size GlobalCatCacheMapSize(void);
+static Size GlobalRelCacheMapSize(void);
+
+GlobalCatCacheMapLock *globalCatCacheMapLock = NULL;
+GlobalRelCacheMapLock *globalRelCacheMapLock = NULL;
+
+/*
+ * --------------------------------------------------------------
+ * Utilities for cache handle
+ * --------------------------------------------------------------
+ */
+
+/*
+ * InitCacheHanlde()
+ * 		Initialize HandleHeader with one free block.
+ *
+ */
+void
+InitCacheHandle(HandleHeader *header, void *owner)
+{
+	HandleBlock *block;
+
+	header->owner = owner;
+
+	LWLockInitialize(&header->freelist_lock, LWTRANCHE_CACHE_HANDLE);
+
+	dlist_init(&header->freelist);
+
+	/* Caller should switch to appropriate shared context */
+	block = InitHandleBlock();
+
+	dlist_push_head(&header->freelist, &block->node);
+}
+
+static HandleBlock *
+InitHandleBlock(void)
+{
+	HandleBlock *block;
+	int i;
+
+	Assert(IsA((CurrentMemoryContext), ShmRetailContext) ||
+		   IsA((CurrentMemoryContext), ShmZoneContext));
+
+	/* Assume MemoryContext is already switched */
+	block = (HandleBlock *) palloc0(sizeof(HandleBlock));
+
+	block->nfree = HANDLE_BLOCK_SIZE;
+
+	block->infreelist = true;
+
+	/* Initialize locks for partition of hash table */
+	SpinLockInit(&block->mutex);
+
+	LWLockInitialize(&block->handle_lock, LWTRANCHE_META_CACHE_HANDLE);
+
+	/* Initailize handle handles */
+	for (i = 0; i < HANDLE_BLOCK_SIZE; ++i)
+	{
+		block->handles[i].free = true;
+		block->handles[i].block = block;
+	}
+	return block;
+}
+
+
+/*
+ * InvalCacheHandle()
+ *  Free the used handle to recycle it.
+ *	When block is not in freelist, push the block to tail of list.
+ */
+void
+InvalCacheHandle(HandleHeader *header, Handle *handle)
+{
+	/* Get lock for the handle and its block */
+	SpinLockAcquire(&handle->block->mutex);
+
+	/* If this function is concurrently called, the handle might be already freed */
+	if (handle->free)
+	{
+		SpinLockRelease(&handle->block->mutex);
+		return;
+	}
+
+	handle->free = true;
+	handle->generation++;
+	handle->entry = NULL;
+	handle->block->nfree++;
+	SpinLockRelease(&handle->block->mutex);
+
+	/*
+	 * If the block is already in the freelist, do nothing and exit.
+	 * If not, push the block to the list. Check the block is in the list
+	 * or not twice to reduce the locking window.
+	 */
+	if (!handle->block->infreelist)
+	{
+		LWLockAcquire(&header->freelist_lock, LW_EXCLUSIVE);
+
+		/*
+		 * The block might be already pushed concurrently. There is also
+		 * possibility that someone already got the free handle before get LWLock.
+		 */
+		if (!handle->block->infreelist && handle->block->nfree != 0)
+		{
+			handle->block->infreelist = true;
+			dlist_push_tail(&header->freelist, &handle->block->node);
+		}
+		LWLockRelease(&header->freelist_lock);
+	}
+}
+
+
+/*
+ * GetCacheHandle()
+ * 	Return Handle. If not found, build a new free block.
+ */
+Handle *
+GetCacheHandle(HandleHeader *header, void *entry)
+{
+	Handle *handle = NULL;
+	HandleBlock *block = NULL;
+	int i;
+
+	LWLockAcquire(&header->freelist_lock, LW_SHARED);
+
+	/*
+	 * Get the first block of freelist. If no available free block, build a new
+	 * one. To reduce the lock contention, exclusive locking duration is as
+	 * small as possible.  Because a newly added block may become full, we
+	 * check if freelist is empyt recursively.
+	 */
+	while (dlist_is_empty(&header->freelist))
+	{
+		MemoryContext old_context;
+
+		LWLockRelease(&header->freelist_lock);
+
+		/* Append the newly built block */
+		LWLockAcquire(&header->freelist_lock, LW_EXCLUSIVE);
+
+		/* TempGlobalCacheContext = MemoryContextClone(GlobalCacheContext, */
+		/* 											CurTransactionContext); */
+
+		/* old_context = MemoryContextSwitchTo(TempGlobalCacheContext); */
+
+		old_context = MemoryContextSwitchTo(GlobalCacheContext);
+
+		block = InitHandleBlock();
+
+		MemoryContextSwitchTo(old_context);
+
+		/* ShmRetailContextMoveChunk(TempGlobalCacheContext, GlobalCacheContext); */
+
+		dlist_push_head(&header->freelist, &block->node);
+
+		LWLockRelease(&header->freelist_lock);
+
+		LWLockAcquire(&header->freelist_lock, LW_SHARED);
+	}
+
+	block = dlist_head_element(HandleBlock, node, &header->freelist);
+
+	/* Search linearly to find free handle */
+	for (i = 0; i < HANDLE_BLOCK_SIZE; ++i)
+	{
+		if (!block->handles[i].free)
+			continue;
+
+		/* Get lock for handle and its owning block */
+		SpinLockAcquire(&block->mutex);
+
+		/* Check the handle again because it might be already occupied */
+		if (!block->handles[i].free)
+		{
+			SpinLockRelease(&block->mutex);
+			continue;
+		}
+
+		block->nfree--;
+		block->handles[i].generation++;
+		block->handles[i].free = false;
+		handle = &block->handles[i];
+
+		SpinLockRelease(&block->mutex);
+
+		break;
+	}
+
+	LWLockRelease(&header->freelist_lock);
+
+
+	/*
+	 * If the block becomes full, delete from free list and mark it. To reduce
+	 * the lock duration, nfree is checked before lock is acquired and checked
+	 * again after acquation of lock.
+	 */
+	if (block->nfree == 0)
+	{
+		LWLockAcquire(&header->freelist_lock, LW_EXCLUSIVE);
+
+		if (block->infreelist && block->nfree == 0)
+		{
+			block->infreelist = false;
+			dlist_delete(&block->node);
+		}
+		LWLockRelease(&header->freelist_lock);
+	}
+
+	/* Set link from handle to entry */
+	handle->entry = entry;
+
+	return handle;
+}
+
+/*
+ * --------------------------------------------------------------
+ * Utilities for both global catalog and relation cache
+ * --------------------------------------------------------------
+ */
+
+/*
+ * GlobalMetaCacheShmemInit
+ *
+ * This is called during shared-memory initialization
+ *
+ */
+void
+GlobalMetaCacheShmemInit(void)
+{
+	/* do nothing if catalog cache is not global */
+	if (!IS_GLOBAL_META_CACHE)
+		return;
+
+	/* Create GMC area and GlobalCacheContext */
+	GlobalCacheContextShmemInit(SHM_METACACHE_SIZE_MB);
+
+	/* Initialize child contexts of GlobalCacheContext */
+	GlobalCatCacheContextShmemInit();
+	GlobalRelCacheContextShmemInit();
+
+	/* Initialize Maps to associate tag with CatCache and Relation hash table */
+	InitGlobalCatCacheMap();
+	InitGlobalRelCacheMap();
+}
+
+Size
+GlobalMetaCacheShmemSize(void)
+{
+	Size size = 0;
+
+	/* do nothing if catalog cache is not shared */
+	if (!IS_GLOBAL_META_CACHE)
+		return 0;
+
+	/* size of global catalog cache area */
+	size = add_size(size, SHM_METACACHE_SIZE_MB);
+
+	/* size of shared MemoryContext */
+	size = add_size(size, GlobalCacheContextSize());
+	size = add_size(size, GlobalCatCacheContextSize());
+	size = add_size(size, GlobalRelCacheContextSize());
+
+	/* size of lookup hash table */
+	size = add_size(size, GlobalCatCacheMapSize());
+	size = add_size(size, GlobalRelCacheMapSize());
+
+	return size;
+}
+
+
+/*
+ * --------------------------------------------------------------
+ * Utilities for hash table map of global catalog cache
+ * --------------------------------------------------------------
+ */
+
+static void
+InitGlobalCatCacheMap(void)
+{
+	HASHCTL info;
+	size_t init_size;
+	size_t max_size;
+	bool found;
+	int i;
+
+	/* assume no locking is needed yet */
+
+	info.keysize = sizeof(GlobalCatCacheMapKey);
+	info.entrysize = sizeof(GlobalCatCacheMapEnt);
+	info.num_partitions = NUM_MAP_PARTITIONS;
+
+	/*
+	 * Number of CatCache table times DB. Actually, this is slightly more than
+	 * we need because it counts dublicatedly shared catalog cache.
+	 */
+	init_size = max_size = SysCacheSize * NUM_DB;
+
+
+	GlobalCatCacheMap = ShmemInitHash("Global CatCache Map",
+									  init_size, max_size,
+									  &info,
+									  HASH_ELEM | HASH_BLOBS |HASH_PARTITION);
+
+	/* Get the pointer to LWLocks for parition */
+	globalCatCacheMapLock = (GlobalCatCacheMapLock *)
+		ShmemInitStruct("GlobalCatCacheMapLock",
+						sizeof(GlobalCatCacheMapLock),	&found);
+
+	if (!found)
+	{
+		Assert(!IsUnderPostmaster);
+
+		for (i = 0; i < NUM_MAP_PARTITIONS; i++)
+			LWLockInitialize(&globalCatCacheMapLock->locks[i],
+							 LWTRANCHE_META_CACHE_MAP);
+	}
+}
+
+/*
+ * Estimate space needed for mapping hashtable
+ */
+static Size
+GlobalCatCacheMapSize(void)
+{
+	/* size of lookup hash table. see comments in InitGlobalCatCacheMap */
+	return hash_estimate_size((SysCacheSize * NUM_DB), sizeof(GlobalCatCacheMapEnt));
+}
+
+uint32
+GlobalCatCacheMapHashCode(GlobalCatCacheMapKey *keyPtr)
+{
+	return get_hash_value(GlobalCatCacheMap, (void *) keyPtr);
+}
+
+
+GlobalCatCacheMapEnt*
+GlobalCatCacheMapLookup(GlobalCatCacheMapKey *keyPtr, uint32 hashcode)
+{
+	GlobalCatCacheMapEnt *result;
+
+	result = (GlobalCatCacheMapEnt *)
+		hash_search_with_hash_value(GlobalCatCacheMap,
+									(void *) keyPtr,
+									hashcode,
+									HASH_FIND,
+									NULL);
+
+	if (!result)
+		return NULL;
+
+	return result;
+}
+
+bool
+GlobalCatCacheMapInsert(GlobalCatCacheMapKey *keyPtr,
+						uint32 hashcode, GlobalCatCache *gcp)
+{
+	GlobalCatCacheMapEnt *result;
+	bool found;
+
+	result = (GlobalCatCacheMapEnt *)
+		hash_search_with_hash_value(GlobalCatCacheMap,
+									(void *) keyPtr,
+									hashcode,
+									HASH_ENTER,
+									&found);
+
+	if (found)
+		return false;
+
+	result->gcp = gcp;
+
+	return true;
+}
+
+void
+GlobalCatCacheMapInitKey(CatCache *lcp, GlobalCatCacheMapKey *keyPtr)
+{
+	Assert(lcp->cc_type == CC_SHAREDLOCAL);
+
+	keyPtr->dbId = lcp->cc_relisshared ? (Oid) 0 : MyDatabaseId;
+	keyPtr->cacheId = lcp->id;
+}
+
+/*
+ * --------------------------------------------------------------
+ * Utilities for hash table map of global catalog cache
+ * --------------------------------------------------------------
+ */
+static void
+InitGlobalRelCacheMap(void)
+{
+	HASHCTL info;
+	size_t init_size;
+	size_t max_size;
+	bool found;
+	int i;
+
+	/* assume no locking is needed yet */
+	info.keysize = sizeof(GlobalRelCacheMapKey);
+	info.entrysize = sizeof(GlobalRelCacheMapEnt);
+	info.num_partitions = NUM_MAP_PARTITIONS;
+
+	init_size = NUM_DB;
+	max_size = 2 * NUM_DB;
+
+	GlobalRelCacheMap = ShmemInitHash("Global Relcache Map",
+									  init_size, max_size,
+									  &info,
+									  HASH_ELEM | HASH_BLOBS |HASH_PARTITION);
+
+	/* Get the pointer to LWLocks for parition */
+	globalRelCacheMapLock = (GlobalRelCacheMapLock *)
+		ShmemInitStruct("GlobalRelacacheMapLock",
+						sizeof(GlobalRelCacheMapLock),&found);
+
+	if (!found)
+	{
+		Assert(!IsUnderPostmaster);
+
+		for (i = 0; i < NUM_MAP_PARTITIONS; i++)
+			LWLockInitialize(&globalRelCacheMapLock->locks[i],
+							 LWTRANCHE_META_CACHE_MAP);
+	}
+}
+
+/*
+ * Estimate space needed for mapping hashtable
+ */
+static Size
+GlobalRelCacheMapSize(void)
+{
+	size_t max_size = 2 * NUM_DB;
+	return hash_estimate_size(max_size, sizeof(GlobalRelCacheMapEnt));
+}
+
+uint32
+GlobalRelCacheMapHashCode(GlobalRelCacheMapKey *keyPtr)
+{
+	return get_hash_value(GlobalRelCacheMap, (void *) keyPtr);
+}
+
+
+GlobalRelCacheMapEnt*
+GlobalRelCacheMapLookup(GlobalRelCacheMapKey *keyPtr, uint32 hashcode)
+{
+	GlobalRelCacheMapEnt *result;
+
+	result = (GlobalRelCacheMapEnt *)
+		hash_search_with_hash_value(GlobalRelCacheMap,
+									(void *) keyPtr,
+									hashcode,
+									HASH_FIND,
+									NULL);
+
+	if (!result)
+		return NULL;
+
+	return result;
+}
+
+bool
+GlobalRelCacheMapInsert(GlobalRelCacheMapKey *keyPtr,
+						uint32 hashcode,
+						dshash_table_handle global_relcache_handle,
+						HandleHeader *cache_handle_header)
+{
+	GlobalRelCacheMapEnt *result;
+	bool found;
+
+	result = (GlobalRelCacheMapEnt *)
+		hash_search_with_hash_value(GlobalRelCacheMap,
+									(void *) keyPtr,
+									hashcode,
+									HASH_ENTER,
+									&found);
+
+	if (found)
+		return false;
+
+	result->global_relcache_handle = global_relcache_handle;
+	result->cache_handle_header = cache_handle_header;
+
+	return true;
+}
diff --git a/src/backend/utils/cache/syscache.c b/src/backend/utils/cache/syscache.c
index 53d9ddf..bba711f 100644
--- a/src/backend/utils/cache/syscache.c
+++ b/src/backend/utils/cache/syscache.c
@@ -997,6 +997,8 @@ static int	SysCacheSupportingRelOidSize;
 
 static int	oid_compare(const void *a, const void *b);
 
+static inline bool
+SysCacheInvalidteCheck(int cacheId, uint32 hashValue);
 
 /*
  * InitCatalogCache - initialize the caches
@@ -1446,7 +1448,7 @@ SearchSysCacheList(int cacheId, int nkeys,
  *	This routine is only quasi-public: it should only be used by inval.c.
  */
 void
-SysCacheInvalidate(int cacheId, uint32 hashValue)
+SysCacheInvalidate(int cacheId, uint32 hashValue, InvalPhase invalPhase)
 {
 	if (cacheId < 0 || cacheId >= SysCacheSize)
 		elog(ERROR, "invalid cache ID: %d", cacheId);
@@ -1455,9 +1457,31 @@ SysCacheInvalidate(int cacheId, uint32 hashValue)
 	if (!PointerIsValid(SysCache[cacheId]))
 		return;
 
-	CatCacheInvalidate(SysCache[cacheId], hashValue);
+	CatCacheInvalidate(SysCache[cacheId], hashValue, invalPhase);
 }
 
+
+void
+GlobalSysCacheInvalidate(int cacheId, uint32 hashValue)
+{
+	if (!SysCacheInvalidteCheck(cacheId, hashValue))
+		return;
+
+	GlobalCatCacheInvalidate(SysCache[cacheId], hashValue);
+}
+
+static inline bool
+SysCacheInvalidteCheck(int cacheId, uint32 hashValue)
+{
+	if (cacheId < 0 || cacheId >= SysCacheSize)
+		elog(ERROR, "invalid cache ID: %d", cacheId);
+
+	/* if this cache isn't initialized yet, no need to do anything */
+	if (PointerIsValid(SysCache[cacheId]))
+		return true;
+	else
+		return false;
+}
 /*
  * Certain relations that do not have system caches send snapshot invalidation
  * messages in lieu of catcache messages.  This is for the benefit of
diff --git a/src/backend/utils/init/globals.c b/src/backend/utils/init/globals.c
index b1f6291..e32cef5 100644
--- a/src/backend/utils/init/globals.c
+++ b/src/backend/utils/init/globals.c
@@ -148,3 +148,5 @@ int			VacuumCostBalance = 0;	/* working state for vacuum */
 bool		VacuumCostActive = false;
 
 double		vacuum_cleanup_index_scale_factor;
+
+int shared_metacache_mem = 0;
diff --git a/src/backend/utils/misc/guc.c b/src/backend/utils/misc/guc.c
index 9630866..3b312de 100644
--- a/src/backend/utils/misc/guc.c
+++ b/src/backend/utils/misc/guc.c
@@ -83,6 +83,7 @@
 #include "tsearch/ts_cache.h"
 #include "utils/builtins.h"
 #include "utils/bytea.h"
+#include "utils/shared_meta_cache.h"
 #include "utils/float.h"
 #include "utils/guc_tables.h"
 #include "utils/memutils.h"
@@ -2352,6 +2353,20 @@ static struct config_int ConfigureNamesInt[] =
 		NULL, NULL, NULL
 	},
 
+#if !defined(RELCACHE_FORCE_RELEASE) || !defined(CLOBBER_CACHE_ALWAYS) || \
+	!defined(CLOBBER_CACHE_RECURSIVELY) || !defined(CLOBBER_CACHE_RECURSIVELY)
+	{
+		{"shared_metacache_mem", PGC_POSTMASTER, RESOURCES_MEM,
+			gettext_noop("Sets the memory for global system catlog cache and relation cache."),
+			gettext_noop("A value of 0 disables this feature and meta cache is built per backend."),
+			GUC_UNIT_MB
+		},
+		&shared_metacache_mem,
+		0, 0, INT_MAX,
+		NULL, NULL, NULL
+	},
+#endif
+
 	/*
 	 * We use the hopefully-safely-small value of 100kB as the compiled-in
 	 * default for max_stack_depth.  InitializeGUCOptions will increase it if
diff --git a/src/backend/utils/misc/postgresql.conf.sample b/src/backend/utils/misc/postgresql.conf.sample
index e1048c0..a35cfaf 100644
--- a/src/backend/utils/misc/postgresql.conf.sample
+++ b/src/backend/utils/misc/postgresql.conf.sample
@@ -131,6 +131,8 @@
 #maintenance_work_mem = 64MB		# min 1MB
 #autovacuum_work_mem = -1		# min 1MB, or -1 to use maintenance_work_mem
 #logical_decoding_work_mem = 64MB	# min 64kB
+#shared_metacache_mem = 0MB		# zero disables the feature
+					# (change requires restart)
 #max_stack_depth = 2MB			# min 100kB
 #shared_memory_type = mmap		# the default is the first option
 					# supported by the operating system:
diff --git a/src/include/storage/lwlock.h b/src/include/storage/lwlock.h
index 8fda8e4..dce17e7 100644
--- a/src/include/storage/lwlock.h
+++ b/src/include/storage/lwlock.h
@@ -220,6 +220,11 @@ typedef enum BuiltinTrancheIds
 	LWTRANCHE_TBM,
 	LWTRANCHE_PARALLEL_APPEND,
 	LWTRANCHE_SXACT,
+	LWTRANCHE_SHARED_MCXT,
+	LWTRANCHE_CACHE_HANDLE,
+	LWTRANCHE_META_CACHE_MAP,
+	LWTRANCHE_GLOBAL_CATCACHE,
+	LWTRANCHE_META_CACHE_HANDLE,
 	LWTRANCHE_FIRST_USER_DEFINED
 }			BuiltinTrancheIds;
 
diff --git a/src/include/storage/sinval.h b/src/include/storage/sinval.h
index 903818b..8e84985 100644
--- a/src/include/storage/sinval.h
+++ b/src/include/storage/sinval.h
@@ -149,5 +149,7 @@ extern void ProcessCommittedInvalidationMessages(SharedInvalidationMessage *msgs
 												 Oid dbid, Oid tsid);
 
 extern void LocalExecuteInvalidationMessage(SharedInvalidationMessage *msg);
-
+extern void GMCEOXactExecInvalMessage(SharedInvalidationMessage *msg);
+extern void GMCAbortSubXactExecInvalMessage(SharedInvalidationMessage *msg);
+extern void GMCEOCommandExecInvalMessage(SharedInvalidationMessage *msg);
 #endif							/* SINVAL_H */
diff --git a/src/include/utils/catcache.h b/src/include/utils/catcache.h
index f4aa316..7f4ddec 100644
--- a/src/include/utils/catcache.h
+++ b/src/include/utils/catcache.h
@@ -34,6 +34,7 @@
 
 #define CATCACHE_MAXKEYS		4
 
+#define GET_CACHEID(catcache) (catcache->id)
 
 /* function computing a datum's hash */
 typedef uint32 (*CCHashFN) (Datum datum);
@@ -41,9 +42,39 @@ typedef uint32 (*CCHashFN) (Datum datum);
 /* function computing equality of two datums */
 typedef bool (*CCFastEqualFN) (Datum a, Datum b);
 
+/* Forward declarations */
+typedef struct GlobalCatCache GlobalCatCache;
+typedef struct LocalCatCTup LocalCatCTup;
+typedef struct GlobalCatCTup GlobalCatCTup;
+
+typedef enum InvalPhase InvalPhase;
+
+/*
+ * CatCache type
+ * CC_REGULAR: CatCache and its entry are located in CacheMemoryContext
+ *
+ * CC_SHAREDLOCAL: CatCache and its entry are located in CacheMemoryContext
+ *  but its entry doesn't have actual tuple locally but points to handle
+ *  for global cache entry located in shared memory. When cache tuple
+ *  is uncommitted, the entry has the tuple locally and doesn't point to
+ *  its handle. Negative entry is storaed locally and doesn't use its
+ *  handle either.
+ *
+ * CC_SHAREDGLOBAL: CatCache and its entry are located in shared memory.
+ *   Negative entry is not stored. Each cache entry has corresponding
+ *   handle and can be accessed via handle.
+ */
+typedef enum
+{
+	CC_REGULAR,
+	CC_SHAREDLOCAL,
+	CC_SHAREDGLOBAL
+} CatCacheType;
+
 typedef struct catcache
 {
 	int			id;				/* cache identifier --- see syscache.h */
+	CatCacheType cc_type;		/* type of catcache --- see CatCacheType */
 	int			cc_nbuckets;	/* # of hash buckets in this cache */
 	TupleDesc	cc_tupdesc;		/* tuple descriptor (copied from reldesc) */
 	dlist_head *cc_bucket;		/* hash buckets */
@@ -62,6 +93,11 @@ typedef struct catcache
 	ScanKeyData cc_skey[CATCACHE_MAXKEYS];	/* precomputed key info for heap
 											 * scans */
 
+	/* materials for global meta cache */
+	GlobalCatCache *gcp; 		/* Global CatCache */
+	SubTransactionId cc_skip_global_subxid; /* subxid when all cache
+											 * is invalidated */
+
 	/*
 	 * Keep these at the end, so that compiling catcache.c with CATCACHE_STATS
 	 * doesn't break ABI for other modules
@@ -89,7 +125,6 @@ typedef struct catctup
 #define CT_MAGIC   0x57261502
 
 	uint32		hash_value;		/* hash value for this tuple's keys */
-
 	/*
 	 * Lookup keys for the entry. By-reference datums point into the tuple for
 	 * positive cache entries, and are separately allocated for negative ones.
@@ -175,6 +210,7 @@ typedef struct catclist
 	short		nkeys;			/* number of lookup keys specified */
 	int			n_members;		/* number of member tuples */
 	CatCache   *my_cache;		/* link to owning catcache */
+	LocalCatCTup  **shared_local_members; /* used when catcache is global */
 	CatCTup    *members[FLEXIBLE_ARRAY_MEMBER]; /* members */
 } CatCList;
 
@@ -188,6 +224,7 @@ typedef struct catcacheheader
 
 /* this extern duplicates utils/memutils.h... */
 extern PGDLLIMPORT MemoryContext CacheMemoryContext;
+extern PGDLLIMPORT MemoryContext GlobalCatCacheContext;
 
 extern void CreateCacheMemoryContext(void);
 
@@ -218,8 +255,9 @@ extern CatCList *SearchCatCacheList(CatCache *cache, int nkeys,
 extern void ReleaseCatCacheList(CatCList *list);
 
 extern void ResetCatalogCaches(void);
-extern void CatalogCacheFlushCatalog(Oid catId);
-extern void CatCacheInvalidate(CatCache *cache, uint32 hashValue);
+extern void CatalogCacheFlushCatalog(Oid catId, InvalPhase invalPhase);
+extern void CatCacheInvalidate(CatCache *cache, uint32 hashValue, InvalPhase invalPhase);
+extern void GlobalCatCacheInvalidate(CatCache *cache, uint32 hashValue);
 extern void PrepareToInvalidateCacheTuple(Relation relation,
 										  HeapTuple tuple,
 										  HeapTuple newtuple,
@@ -228,4 +266,7 @@ extern void PrepareToInvalidateCacheTuple(Relation relation,
 extern void PrintCatCacheLeakWarning(HeapTuple tuple);
 extern void PrintCatCacheListLeakWarning(CatCList *list);
 
+//ideriha
+extern void PrintAllCatCacheInfo(void);
+
 #endif							/* CATCACHE_H */
diff --git a/src/include/utils/shared_meta_cache.h b/src/include/utils/shared_meta_cache.h
new file mode 100644
index 0000000..f2bd7fb
--- /dev/null
+++ b/src/include/utils/shared_meta_cache.h
@@ -0,0 +1,170 @@
+/*-------------------------------------------------------------------------
+ *
+ * shared_meta_cache.h
+ *	  Routines for shared catalog/relation cache
+ *
+ * Portions Copyright (c) 1996-2019, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ * src/include/utils/shared_meta_cache.h
+ *
+ *-------------------------------------------------------------------------
+ */
+#ifndef SHARED_META_CACHE_H
+#define SHARED_META_CACHE_H
+
+#include "lib/ilist.h"
+#include "lib/dshash.h"
+#include "storage/lwlock.h"
+#include "utils/catcache.h"
+
+/* Number of partitions of the shared cache mapping hashtable */
+#define NUM_MAP_PARTITIONS  8
+#define IS_GLOBAL_META_CACHE (shared_metacache_mem != 0)
+
+/* invalidation phase used in shared catalog/relation cache */
+typedef enum InvalPhase
+{
+	INVAL_COMMON, /* 1. when meta cache is not shared
+				   * 2. when sinval is read */
+	INVAL_GMC_COMMIT_XACT, /* when transaction is committed */
+	INVAL_GMC_ABORT_XACT,
+	INVAL_GMC_COMMIT_SUBXACT,
+	INVAL_GMC_ABORT_SUBXACT, /* when sub-transaction is aborted */
+	INVAL_GMC_EO_COMMAND /* end of command */
+} InvalPhase;
+
+
+/*
+ * Declarations for cache handle
+ */
+typedef struct HandleHeader HandleHeader;
+typedef struct HandleBlock HandleBlock;
+typedef struct Handle Handle;
+
+struct Handle
+{
+	bool free; 			/* is chunk free? */
+	int generation;     /* how many times this chunk is recycled */
+	HandleBlock *block; /* block owning this chunk */
+	void *entry; 	/* link to global catalog/relation cache entry */
+};
+
+struct HandleBlock
+{
+	dlist_node node; /* dlist node */
+	uint32 nfree; 	/* number of free handles */
+	bool infreelist;   	/* if it's a member of freelist or not */
+	slock_t mutex; /* lock for Handle members and above except for infreelist */
+#define HANDLE_BLOCK_SIZE 32
+	Handle handles[HANDLE_BLOCK_SIZE];
+	LWLock handle_lock; /* lock for get/invalidate handle operation */
+};
+
+struct HandleHeader
+{
+	dlist_head freelist;  /* head of the free block list */
+	LWLock freelist_lock; /* lock for freelist and HandleBlock->infreelist */
+	void *owner; /* Global Hash table of either catcache or relcache */
+};
+
+/*
+ * Declarations for shared catalog cache map
+ */
+
+/* If CatCache is shared across database, it's pushed to list whose dbid is 0 */
+typedef struct GlobalCatCacheMapKey
+{
+	Oid dbId; 		/* database oid, if shared cache, 0 */
+	int cacheId; 	/* catcache id */
+} GlobalCatCacheMapKey;
+
+typedef struct GlobalCatCacheMapEnt
+{
+	GlobalCatCacheMapKey key; /* tag of a CatCache hash table */
+	GlobalCatCache *gcp;   /* associated CatCache hash table */
+} GlobalCatCacheMapEnt;
+
+/* LWLock for each partition */
+typedef struct GlobalCatCacheMapLock
+{
+	LWLock locks[NUM_MAP_PARTITIONS];
+} GlobalCatCacheMapLock;
+
+extern GlobalCatCacheMapLock *globalCatCacheMapLock;
+
+/*
+ * Declarations for shared relation cache map
+ */
+typedef Oid GlobalRelCacheMapKey;
+
+typedef struct GlobalRelCacheMapEnt
+{
+	GlobalRelCacheMapKey key; /* key of a RelCache hash table */
+	dshash_table_handle global_relcache_handle; /* RelCache hash table handle */
+	HandleHeader *cache_handle_header; /* header for handles */
+} GlobalRelCacheMapEnt;
+
+typedef struct GlobalRelCacheMapLock
+{
+	LWLock locks[NUM_MAP_PARTITIONS];
+} GlobalRelCacheMapLock;
+
+extern GlobalRelCacheMapLock *globalRelCacheMapLock;
+
+/* GUC parameter: 0 indicates catalog/relation cache is built per backend */
+extern int shared_metacache_mem;
+
+/* Unit is megabyte */
+#define SHM_METACACHE_SIZE_MB ((size_t)(1024 * 1024 * shared_metacache_mem))
+#define GET_HANDLE_LOCK(handle) (&handle->block->handle_lock)
+
+/*
+ * The shared cache mapping table is partitioned to reduce contention.
+ * To determine which partition lock a given key requires, compute the key's
+ * hash code with GlobalCatCacheMapHashCode(), then apply
+ * SharedCachePartitionLock().
+ * NB: NUM_MAP_PARTITIONS must be a power of 2!
+ */
+#define GlobalCacheMapHashPartition(hashcode) \
+	((hashcode) % NUM_MAP_PARTITIONS)
+#define GlobalCatCachePartitionLock(hashcode) \
+	(&globalCatCacheMapLock->locks[GlobalCacheMapHashPartition(hashcode)])
+#define GlobalRelCachePartitionLock(hashcode) \
+	(&globalRelCacheMapLock->locks[GlobalCacheMapHashPartition(hashcode)])
+
+extern void GlobalMetaCacheShmemInit(void);
+extern Size GlobalMetaCacheShmemSize(void);
+
+/* routines for cache handle */
+extern void InitCacheHandle(HandleHeader *header, void *owner);
+extern void InvalCacheHandle(HandleHeader *header, Handle *chunk);
+extern Handle *GetCacheHandle(HandleHeader *header, void *entry);
+
+/* routines for shared hash map */
+extern void GlobalCatCacheMapInitKey(CatCache *lcp,
+									 GlobalCatCacheMapKey *keyPtr);
+
+extern uint32 GlobalCatCacheMapHashCode(GlobalCatCacheMapKey *keyPtr);
+
+extern GlobalCatCacheMapEnt*
+GlobalCatCacheMapLookup(GlobalCatCacheMapKey *keyPtr, uint32 hashcode);
+
+extern bool
+GlobalCatCacheMapInsert(GlobalCatCacheMapKey *keyPtr,
+						uint32 hashcode,
+						GlobalCatCache *gcp);
+
+extern uint32
+GlobalRelCacheMapHashCode(GlobalRelCacheMapKey *keyPtr);
+
+extern GlobalRelCacheMapEnt*
+GlobalRelCacheMapLookup(GlobalRelCacheMapKey *keyPtr, uint32 hashcode);
+
+extern bool
+GlobalRelCacheMapInsert(GlobalRelCacheMapKey *keyPtr,
+						uint32 hashcode,
+						dshash_table_handle global_relcache_handle,
+						HandleHeader *cache_handle_header);
+
+#endif							/* SHARED_META_CACHE_H */
diff --git a/src/include/utils/syscache.h b/src/include/utils/syscache.h
index f27b73d..8b2a46d 100644
--- a/src/include/utils/syscache.h
+++ b/src/include/utils/syscache.h
@@ -18,6 +18,7 @@
 
 #include "access/attnum.h"
 #include "access/htup.h"
+#include "utils/shared_meta_cache.h"
 /* we intentionally do not include utils/catcache.h here */
 
 /*
@@ -160,12 +161,15 @@ struct catclist;
 extern struct catclist *SearchSysCacheList(int cacheId, int nkeys,
 										   Datum key1, Datum key2, Datum key3);
 
-extern void SysCacheInvalidate(int cacheId, uint32 hashValue);
+extern void SysCacheInvalidate(int cacheId, uint32 hashValue, InvalPhase invalPhase);
 
 extern bool RelationInvalidatesSnapshotsOnly(Oid relid);
 extern bool RelationHasSysCache(Oid relid);
 extern bool RelationSupportsSysCache(Oid relid);
 
+/* For GlobalCatCache */
+extern void GlobalSysCacheInvalidate(int cacheId, uint32 hashValue);
+
 /*
  * The use of the macros below rather than direct calls to the corresponding
  * functions is encouraged, as it insulates the caller from changes in the
